/*
 * Copyright (c) 2010-2011 Stefan Bolte <portix@gmx.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

static KeyValue KEYS[] = {
  { "add_view",                 {   "ga",         0,                  },  },  
  { "allow_cookie",             {   "CC",         0,                   },  },  
  { "bookmark",                 {   "M",         0,                   },  },  
  { "bookmarks",                {   "gb",        0,                   },  },  
  { "bookmarks_nv",             {   "gB",        0,                   },  },  
  { "bookmarks_nw",             {   "wB",        0,                   },  },  
  { "command_mode",             {   ":",         0,                   },  },  
  { "only",                     {   "co",         0,                   },  },  
  { "find_forward",             {   "/",         0,                   },  }, 
  { "find_next",                {   "n",         0,                   },  },
  { "find_previous",            {   "N",         0,                   },  },
  { "find_backward",            {   "?",         0,                   },  },  
  { "focus_next",               {   "J",         0,                   },  },  
  { "focus_prev",               {   "K",         0,                   },  },  
  { "focus_nth_view",           {   "T",         0,                   },  },  
  { "hint_mode",                {   "f",         0,                   },  },  
  { "hint_mode_links",          {   ";;",         0,                   },  },  
  { "hint_mode_images",         {   ";i",         0,                   },  },  
  { "hint_mode_images_nv",      {   ";I",         0,                   },  },  
  { "hint_mode_editable",       {   ";e",         0,                   },  },  
  { "hint_mode_url",            {   ";o",         0,                   },  },  
  { "hint_mode_url_nv",         {   ";O",         0,                   },  },  
  { "hint_mode_download",       {   ";d",           0 }, },
  { "hint_mode_nv",             {   "F",         0,                   },  },  
  { "hint_mode_nw",             {   "wf",         0,                   },  },  
  { "hint_mode_clipboard",      {   ";y",         0,                   },  },  
  { "hint_mode_primary",        {   ";Y",         0,                   },  },  
  { "history_back",             {   "H",         0,                   },  },  
  { "history_forward",          {   "L",         0,                   },  },  
  { "insert_mode",              {   "i",         0,                   },  },  
  { "increase_master",          {   "gl",         0,                  },  },  
  { "decrease_master",          {   "gh",         0,                  },  },  
  { "open",                     {   "o",         0,                   },  },  
  { "Open",                     {   "go",        0,                   },  }, 
  { "open_nv",                  {   "O",         0,                   },  },  
  { "Open_nv",                  {   "gO",         0,                   },  },  
  { "open_nw",                  {   "wo",         0,                   },  },  
  { "Open_nw",                  {   "wO",         0,                   },  },  
  { "open_start_page",          {   "h",         GDK_CONTROL_MASK,    },  },  
  { "open_quickmark",           {   "b",         0,                   },  },  
  { "open_quickmark_nv",        {   "B",         0,                   },  },  
  { "open_quickmark_nw",        {   "wb",        0,                   },  },  
  { "push_master",              {   "gp",        0,    },  },  
  { "reload",                   {   "r",         0,                   },  },  
  { "reload_bypass_cache",      {   "R",         0,                   },  },  
  { "remove_view",              {   "d",         0,                   },  },  
  { "save_quickmark",           {   "m",         0,                   },  },  
  { "scroll_percent",           {   "%",         0,                   },  },  
  { "scroll_bottom",            {   "G",         0,                   },  },  
  { "scroll_down",              {   "j",         0,                   },  },  
  { "scroll_left",              {   "h",         0,                   },  },  
  { "scroll_halfpage_down",     {   "d",         GDK_CONTROL_MASK,    },  },  
  { "scroll_halfpage_up",       {   "u",         GDK_CONTROL_MASK,    },  },  
  { "scroll_page_down",         {   "f",         GDK_CONTROL_MASK,    },  },  
  { "scroll_page_up",           {   "b",         GDK_CONTROL_MASK,    },  },  
  { "scroll_right",             {   "l",         0,                   },  },  
  { "scroll_top",               {   "gg",         0,                  },  },  
  { "scroll_up",                {   "k",         0,                   },  },  
  { "show_keys",                {   "Sk",         0,                  },  },  
  { "show_settings",            {   "Ss",        0,                  },  },  
  { "stop_loading",             {   "s",         GDK_CONTROL_MASK,   },  },  
  { "toggle_bottomstack",       {   "tb",         0,  },  },  
  { "toggle_maximized",         {   "gm",         0,                  },  },  
  { "view_source",              {   "gf",         0,                  },  },  
  { "zoom_in",                  {   "zi",         0,                  },  },  
  { "zoom_normal",              {   "z=",         0,                  },  },  
  { "zoom_out",                 {   "zo",         0,                  },  },  
  { "save_search_field",        {   "gs",         0,                  },  },  
  { "autoload_images",          {   NULL,           0,                  },  },
  { "autoresize_window",        {   NULL,           0,                  },  },
  { "autoshrink_images",        {   NULL,           0,                  },  },
  { "caret_browsing",           {   NULL,           0,                  },  },
  { "java_applets",             {   NULL,           0,                  },  },
  { "plugins",                  {   NULL,           0,                  },  },
  { "private_browsing",         {   NULL,           0,                  },  },
  { "scripts",                  {   NULL,           0,                  },  },
  { "spell_checking",           {   NULL,           0,                  },  },
  { "reload_scripts",           {   NULL,           0,                  },  },
  { "proxy",                    {   "p" ,           GDK_CONTROL_MASK,  },  },
  { "focus_input",              {   "gi",           0, }, }, 
  { "set_setting",              {   "ss",           0, }, }, 
  { "set_global_setting",       {   "sgs",           0, }, }, 
  { "set_key",                  {   "sk",           0, }, }, 
  { "yank",                     {   "yy",           0, }, }, 
  { "yank_primary",             {   "yY",           0, }, }, 
  { "yank_title",               {   "yt",           0, }, }, 
  { "yank_title_primary",       {   "yT",           0, }, }, 
  { "paste",                    {   "pp",           0, }, }, 
  { "paste_primary",            {   "pP",           0, }, }, 
  { "paste_nv",                 {   "Pp",           0, }, }, 
  { "paste_primary_nv",         {   "PP",           0, }, }, 
  { "paste_nw",                 {   "wp",           0, }, }, 
  { "paste_primary_nw",         {   "wP",           0, }, }, 
  /* entry  shortcuts */
  { "entry_delete_word",        {   "w",            GDK_CONTROL_MASK, }, }, 
  { "entry_delete_letter",      {   "h",            GDK_CONTROL_MASK, }, }, 
  { "entry_delete_line",        {   "u",            GDK_CONTROL_MASK, }, }, 
  { "entry_word_forward",       {   "f",            GDK_CONTROL_MASK, }, }, 
  { "entry_word_back",          {   "b",            GDK_CONTROL_MASK, }, }, 
  { "entry_history_forward",    {   "j",            GDK_CONTROL_MASK, }, }, 
  { "entry_history_back",       {   "k",            GDK_CONTROL_MASK, }, }, 
  { "download_set_execute",     {   "x",            GDK_CONTROL_MASK, }, }, 
  { "complete_history",         {   "H",         GDK_CONTROL_MASK,     },  },  
  { "complete_bookmarks",       {   "B",         GDK_CONTROL_MASK,     },  },  
  { "complete_commands",        {   "I",         GDK_CONTROL_MASK,     },  },  
  { "complete_searchengines",   {   "S",         GDK_CONTROL_MASK,     },  },  
  { "complete_userscript",      {   "U",         GDK_CONTROL_MASK,     },  },  
  { "complete_current_history", {   "C",         GDK_CONTROL_MASK,     },  },  
  { "buffers",                  {   "gt",         0 } }, 

  { "web_inspector",            {   "wi",         0,     },  },  

  { "save_session",             {   "ZZ",           0 }, }, 
  { "save_named_session",       {   "gZZ",           0 }, }, 
  { "toggle_scripts_uri",       {   "tsu",           0 }, }, 
  { "toggle_scripts_host",      {   "tsh",           0 }, }, 
  { "toggle_scripts_uri_tmp",   {   "ttu",           0 }, }, 
  { "toggle_scripts_host_tmp",  {   "tth",           0 }, }, 
  { "toggle_plugins_uri",       {   "pu",           0 }, }, 
  { "toggle_plugins_host",      {   "ph",           0 }, }, 
  { "toggle_plugins_uri_tmp",   {   "ptu",           0 }, }, 
  { "toggle_plugins_host_tmp",  {   "pth",           0 }, }, 
  { "new_view",                 {   "V",            0 }, }, 
  { "new_window",               {   "W",            0 }, }, 
  { "save",                     {   "sf",            0 }, }, 
  { "undo",                     {   "u",            0 }, }, 
  { "execute_userscript",       {   "eu",           0 }, },  
  { "print",                    {   "p",            GDK_CONTROL_MASK | GDK_MOD1_MASK }, }, 
  { "load_html",                    {   NULL,         0 }, }, 
  { "load_html_nv",                    {   NULL,         0 }, }, 
  { "toggle_hidden_files",          {   "g.",         0 }, }, 
  { "complete_path",          {   "p",         GDK_CONTROL_MASK }, }, 
  { "quit",                   {   "q",         GDK_CONTROL_MASK }, }, 
  { "fullscreen",             {   "F11",         GDK_CONTROL_MASK }, }, 
  { "pass_through",           {   "i",        GDK_CONTROL_MASK }, }, 
  { "open_editor",            {   "e",        GDK_CONTROL_MASK }, }, 
};
